import 'dart:math';

import 'package:dart_blocks/os_mobile_blocks/models/auth.dart';
import 'package:dart_blocks/os_mobile_blocks/user_block_cupertino/AuthPage/LoginPage/login_page.dart';
import 'package:dart_blocks/os_mobile_blocks/user_block_cupertino/AuthPage/RegisterPage/register_page.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class WelcomePage extends StatelessWidget {
  WelcomePage({
    Key? key,
    required this.createdBy,
    required this.welcomeLogo,
    required this.welcomeTitle,
    required this.welcomeDetails,
    required this.loginButtonText,
    required this.registerButtonText,
    required this.onLogin,
    required this.emailLoginHint,
    required this.passwordLoginHint,
    required this.emailRegisterHint,
    required this.passwordRegisterHint,
    required this.loginDetailsTitle,
    required this.registerDetails,
    required this.onRegister,
    required this.primaryColor,
    required this.secondaryColor,
    required this.loginTitle,
    required this.registerTitle,
    required this.loginLogo,
    required this.registerLogo,
    required this.repeatPasswordRegisterHint,
    required this.background,
    required this.textFieldBorder,
  });

  // general
  final Widget createdBy;
  final Color primaryColor;
  final Color secondaryColor;
  final BoxDecoration background;
  final Border? textFieldBorder;

  // welcome
  final Widget welcomeLogo;
  final Widget welcomeTitle;
  final Widget welcomeDetails;

  // login
  final Widget loginLogo;
  final Widget loginButtonText;
  final Widget loginDetailsTitle;
  final Widget loginTitle;
  final Function onLogin;
  final String emailLoginHint;
  final String passwordLoginHint;

  // register
  final Widget registerLogo;
  final Widget registerButtonText;
  final Widget registerDetails;
  final Function onRegister;
  final String emailRegisterHint;
  final String passwordRegisterHint;
  final String repeatPasswordRegisterHint;
  final Widget registerTitle;

  AuthEnum auth = AuthEnum.signIn;

  @override
  Widget build(BuildContext context) {
    // This method is rerun every time setState is called, for instance as done
    // by the _incrementCounter method above.
    //
    // The Flutter framework has been optimized to make rerunning build methods
    // fast, so that you can just rebuild anything that needs updating rather
    // than having to individually change instances of widgets.
    return CupertinoPageScaffold(
      child: Container(
        decoration: background,
        child: Padding(
          padding: const EdgeInsets.all(20),
          child: Align(
            alignment: Alignment.center,
            child: Column(
              mainAxisAlignment: MainAxisAlignment.center,
              children: <Widget>[
                const Spacer(),
                welcomeLogo,
                const SizedBox(
                  height: 30,
                ),
                welcomeTitle,
                const SizedBox(
                  height: 15,
                ),
                welcomeDetails,
                const Spacer(),
                CupertinoButton(
                  color: primaryColor,
                  onPressed: () {
                    Navigator.push(
                      context,
                      CupertinoPageRoute(
                        builder: (context) => LoginPage(
                          border: textFieldBorder,
                          emailHint: emailLoginHint,
                          createdBy: createdBy,
                          background: background,
                          primaryColor: primaryColor,
                          secondaryColor: Colors.white,
                          title: loginTitle,
                          logo: loginLogo,
                          passwordHint: passwordLoginHint,
                          onLogin: onLogin,
                          details: loginDetailsTitle,
                          loginButtonText: loginButtonText,
                        ),
                      ),
                    );
                  },
                  child: loginButtonText,
                ),
                const SizedBox(
                  height: 20,
                ),
                CupertinoButton(
                  color: secondaryColor,
                  onPressed: () {
                    Navigator.push(
                      context,
                      CupertinoPageRoute(
                        builder: (context) => RegisterPage(
                          border: textFieldBorder,
                          secondaryColor: secondaryColor,
                          primaryColor: primaryColor,
                          buttonText: registerButtonText,
                          emailHint: emailRegisterHint,
                          background: background,
                          passwordHint: passwordRegisterHint,
                          repeatPasswordHint: repeatPasswordRegisterHint,
                          details: registerDetails,
                          onRegister: () => {},
                          title: registerTitle,
                          logo: registerLogo,
                          createdBy: createdBy,
                        ),
                      ),
                    );
                  },
                  child: registerButtonText,
                ),
                const SizedBox(
                  height: 50,
                ),
                createdBy,
              ],
            ),
          ),
        ),
      ),
    );
  }
}
